
Module GlobalFunctions

    Public Function Get_Error_Information(ByVal szLinkTyp As String, ByVal nComError As Integer, _
                                    ByVal szComError As String, ByVal MsgStyle As MsgBoxStyle, _
                                    ByVal szMsgTitle As String, ByVal szMsgInfo As String) As Integer

        ' Hier geben wir die Detailinformationen zum Aufgetretenen Fehler aus
        MsgBox("Es ist folgender Fehler aufgetreten!" _
        & vbCrLf & szLinkTyp _
        & vbCrLf & "Error-Code: " & nComError _
        & vbCrLf & "Error-Info: " & szMsgInfo _
        & vbCrLf & vbCrLf _
        & "Beschreibung:" _
        & vbCrLf _
        & szComError, MsgStyle, szMsgTitle)

    End Function

    Public Function CallExseptionInfo(ByVal ComNum As Integer, ByVal nError As Integer, _
                                  ByVal Language As Integer, ByVal szError As String, _
                                  ByVal StringLength As Integer, ByVal MsgStyle As MsgBoxStyle, _
                                  ByVal MsgTitle As String, ByVal szLinkTyp As String, _
                                  ByVal szMsgInfo As String) As Integer

        Select Case m_nLinkDLLType
            Case 1 ' Declare
                CallingVariations.DFCGetErrorText_Declare(ComNum, _
                                                            nError, 0, szError, StringLength)
            Case 2 ' Import
            Case 3 ' Unicode
            Case 4 ' ANSI 
                CallingVariations.DFCGetErrorText_ANSI(ComNum, _
                                                            nError, 0, szError, StringLength)
            Case 5 ' Auto
        End Select

        Get_Error_Information(szLinkTyp, nError, szError, MsgStyle, MsgTitle, szMsgInfo)

    End Function


    Public Function GetListDefinition(ByRef pRichBox As RichTextBox) As Integer

        Dim nComError As Integer

        Dim LDName As String ' Name eine Listenbeschreibung
        Dim LDField As String ' Name eines Feldes
        Dim length(33) As Char
        LDName = New String(length) ' Bereitstellung des Speichers
        LDField = New String(length) ' Bereitstellung des Speichers

        Dim LDFieldCount As Integer ' Anzahl der Felder in einer Listenbeschreibung
        Dim LDFieldTyp As Integer ' Feldtyp eines Datensatzfeldes
        Dim LDFieldLength As Integer ' Lnge eines Feldes laut Datensatzbeschreibung
        Dim LDLength As Integer ' Datensatzlnge
        '       Dim LDStatus As Integer
        Dim LDListTyp As Integer ' Gibt an, ob es eine variable Liste ist oder nicht


        Dim iDFComResult As Integer ' Rckgabewert der DFComDLL Funktionsaufrufe

        ' Als erstes mssen wir die Datensatzbeschreibung auslesen
        Select Case m_nLinkDLLType
            Case 1 ' declare
                ' Die Listenbeschreibung wird im DLL - Buffer abgelegt
                iDFComResult = CallingVariations.DFCLoadListenbeschreibung_Declare(1, 254, nComError)
            Case 2 ' import
            Case 3 ' unicode
            Case 4 ' ansi 
                ' Die Listenbeschreibung wird im DLL - Buffer abgelegt
                iDFComResult = CallingVariations.DFCLoadListenbeschreibung_ANSI(1, 254, nComError)
            Case 5 ' auto
        End Select
        ' Wir geben hier ein Feedback fr den Anwender
        pRichBox.AppendText("Listenbeschreibungen aus dem Gert auslesen: <DFCLoadListenbeschreibung()>")
        pRichBox.AppendText(vbCrLf)

        If (iDFComResult = 1) Then

            ' prfen wie viele Datensatzbeschreibungen definiert sind
            Select Case m_nLinkDLLType
                Case 1 ' Declare
                    GlobalDefs.LDCount = CallingVariations.DFCListBCnt_Declare(1)
                Case 2 ' Import
                Case 3 ' Unicode
                Case 4 ' ANSI 
                    GlobalDefs.LDCount = CallingVariations.DFCListBCnt_ANSI(1)
                Case 5 ' Auto
            End Select
            ' Wir geben hier ein Feedback fr den Anwender
            pRichBox.AppendText("Anzahl der Listenbeschreibungen ermitteln: <DFCListBCnt()>: ermittelte Anzahl = " & GlobalDefs.LDCount.ToString)
            pRichBox.AppendText(vbCrLf)
            pRichBox.AppendText(vbCrLf)

            ' Speicher fr die Listenbeschreibungen alokieren
            ReDim STL(GlobalDefs.LDCount)


            ' Das ganze muss fr jede Datensatzbeschreibung abgearbeitet werden
            For list As Integer = 0 To GlobalDefs.LDCount - 1
                ' Name der Datensatzbeschreibung ermitteln und speichern
                Select Case m_nLinkDLLType
                    Case 1 ' Declare
                        iDFComResult = CallingVariations.DFCListBDatensatz_Declare(1, list, LDName, LDFieldCount, LDListTyp)
                    Case 2 ' Import
                    Case 3 ' Unicode
                    Case 4 ' ANSI 
                        iDFComResult = CallingVariations.DFCListBDatensatz_ANSI(1, list, LDName, LDFieldCount, LDListTyp)
                    Case 5 ' Auto
                End Select

                STL(list).LiID = list                               ' Nummer der Datensatzbeschreibung
                STL(list).LiName = LDName                           ' Name der Datensatzbeschreibung
                STL(list).LiFieldCount = LDFieldCount               ' Anzahl Felder 
                STL(list).LiStatus = 0                              ' 
                STL(list).LiType = LDListTyp
                ' Hier stellen wir den bentigten Speicher entsprechend der Feldanzahl bereit
                ReDim STL(list).LiFields(LDFieldCount)
                ' Die Datensatzlnge setzen wir zunchst auf Null
                LDLength = 0

                ' Wir geben hier ein Feedback fr den Anwender
                pRichBox.AppendText("Metadaten einer Listenbeschreibung  ermitteln: <DFCListBDatensatz()>: zur Liste = " & LDName)
                pRichBox.AppendText(vbCrLf)
                pRichBox.ScrollToCaret()

                ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
                For fi As Integer = 0 To LDFieldCount - 1
                    ' Zu jedem Feld die Informationen ermitteln und Speichern
                    Select Case m_nLinkDLLType
                        Case 1 ' Declare
                            iDFComResult = CallingVariations.DFCListBFeld_Declare(1, list, fi, LDField, LDFieldTyp, LDFieldLength)
                        Case 2 ' Import
                        Case 3 ' Unicode
                        Case 4 ' ANSI 
                            iDFComResult = CallingVariations.DFCListBFeld_ANSI(1, list, fi, LDField, LDFieldTyp, LDFieldLength)
                        Case 5 ' Auto
                    End Select
                    If (iDFComResult = 1) Then
                        STL(list).LiFields(fi).FiName = LDField         ' Name des Feldes
                        STL(list).LiFields(fi).FiTyp = LDFieldTyp       ' Typ des Feldes
                        STL(list).LiFields(fi).FiLength = LDFieldLength ' Feldlnge in Byte
                        STL(list).LiFields(fi).FiValue = ""             ' Feldwert
                        ' Hier rechnen wir die Datensatzlnge zusammen
                        LDLength = LDLength + LDFieldLength

                        ' Wir geben hier ein Feedback fr den Anwender
                        pRichBox.AppendText("Metadaten eines Feldes ermitteln: <DFCListBFeld()>: zum Feld = " & LDField)
                        pRichBox.AppendText(vbCrLf)

                    Else
                        MsgBox("Fehler: " & iDFComResult.ToString)
                    End If
                Next fi

                ' Die Datensatzlnge wird natrlich auch zur Datensatzbeschreibung gespeichert
                STL(list).LiLength = LDLength
                ' Nchste Datensatzbeschreibung
                pRichBox.AppendText(vbCrLf)

            Next list

        End If

    End Function


    Public Function GetZKListDefinition(ByRef pRichBox As RichTextBox) As Integer

        Dim ZKLDName As String ' Name eine Listenbeschreibung
        Dim ZKLDField As String ' Name eines Feldes
        Dim length(33) As Char
        ZKLDName = New String(length) ' Bereitstellung des Speichers
        ZKLDField = New String(length) ' Bereitstellung des Speichers

        ' Bei den ZK-Listen ist alles fix, daher auch der Code fix
        GlobalDefs.ZKLDCount = 7

        ' Wir geben hier ein Feedback fr den Anwender
        pRichBox.AppendText("Anzahl der ZK-Listenbeschreibungen: = " & GlobalDefs.ZKLDCount.ToString)
        pRichBox.AppendText(vbCrLf)
        pRichBox.AppendText(vbCrLf)
        pRichBox.ScrollToCaret()
        pRichBox.Update()

        ' Speicher fr die Listenbeschreibungen alokieren
        ReDim STLZK(GlobalDefs.ZKLDCount)

        STLZK(0).LiID = 0                               ' Nummer der Datensatzbeschreibung
        STLZK(0).LiName = "Reader"                      ' Name der Datensatzbeschreibung (Reader)
        STLZK(0).LiFieldCount = 6                       ' Anzahl Felder 
        STLZK(0).LiStatus = 0                           ' 
        STLZK(0).LiType = 0
        ' Hier stellen wir den bentigten Speicher entsprechend der Feldanzahl bereit
        ReDim STLZK(0).LiFields(6)
        ' Die Datensatzlnge wird natrlich auch zur Datensatzbeschreibung gespeichert
        STLZK(0).LiLength = 33
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(0).LiFields(0).FiName = "0"       '"Id" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(0).LiFields(0).FiTyp = 1          ' Typ des Feldes
        STLZK(0).LiFields(0).FiLength = 4       ' Feldlnge in Byte
        STLZK(0).LiFields(0).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(0).LiFields(1).FiName = "1"       '"ZM" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(0).LiFields(1).FiTyp = 1          ' Typ des Feldes
        STLZK(0).LiFields(1).FiLength = 4       ' Feldlnge in Byte
        STLZK(0).LiFields(1).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(0).LiFields(2).FiName = "2"       '"TM" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(0).LiFields(2).FiTyp = 1          ' Typ des Feldes
        STLZK(0).LiFields(2).FiLength = 3       ' Feldlnge in Byte
        STLZK(0).LiFields(2).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(0).LiFields(3).FiName = "3"       '"RefLocation" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(0).LiFields(3).FiTyp = 1          ' Typ des Feldes
        STLZK(0).LiFields(3).FiLength = 4       ' Feldlnge in Byte
        STLZK(0).LiFields(3).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(0).LiFields(4).FiName = "4"       ' "RefAction" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(0).LiFields(4).FiTyp = 1          ' Typ des Feldes
        STLZK(0).LiFields(4).FiLength = 4       ' Feldlnge in Byte
        STLZK(0).LiFields(4).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(0).LiFields(5).FiName = "5"       '"Pin" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(0).LiFields(5).FiTyp = 1          ' Typ des Feldes
        STLZK(0).LiFields(5).FiLength = 8       ' Feldlnge in Byte
        STLZK(0).LiFields(5).FiValue = ""       ' Feldwert


        STLZK(1).LiID = 1                               ' Nummer der Datensatzbeschreibung
        STLZK(1).LiName = "Identification"              ' Name der Datensatzbeschreibung
        STLZK(1).LiFieldCount = 7                       ' Anzahl Felder 
        STLZK(1).LiStatus = 0                           ' 
        STLZK(1).LiType = 0
        ' Hier stellen wir den bentigten Speicher entsprechend der Feldanzahl bereit
        ReDim STLZK(1).LiFields(7)
        ' Die Datensatzlnge wird natrlich auch zur Datensatzbeschreibung gespeichert
        STLZK(1).LiLength = 64
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(1).LiFields(0).FiName = "0"       '"Id" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(1).LiFields(0).FiTyp = 4          ' Typ des Feldes
        STLZK(1).LiFields(0).FiLength = 20      ' Feldlnge in Byte
        STLZK(1).LiFields(0).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(1).LiFields(1).FiName = "1"       '"Group" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(1).LiFields(1).FiTyp = 1          ' Typ des Feldes
        STLZK(1).LiFields(1).FiLength = 4       ' Feldlnge in Byte
        STLZK(1).LiFields(1).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(1).LiFields(2).FiName = "2"       '"Pin" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(1).LiFields(2).FiTyp = 1          ' Typ des Feldes
        STLZK(1).LiFields(2).FiLength = 8       ' Feldlnge in Byte
        STLZK(1).LiFields(2).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(1).LiFields(3).FiName = "3"       '"Menace" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(1).LiFields(3).FiTyp = 1          ' Typ des Feldes
        STLZK(1).LiFields(3).FiLength = 4       ' Feldlnge in Byte
        STLZK(1).LiFields(3).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(1).LiFields(4).FiName = "4"       '"ActiveStart" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(1).LiFields(4).FiTyp = 4          ' Typ des Feldes
        STLZK(1).LiFields(4).FiLength = 10      ' Feldlnge in Byte
        STLZK(1).LiFields(4).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(1).LiFields(5).FiName = "5"       '"ActiveEnd" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(1).LiFields(5).FiTyp = 4          ' Typ des Feldes
        STLZK(1).LiFields(5).FiLength = 10      ' Feldlnge in Byte
        STLZK(1).LiFields(5).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(1).LiFields(6).FiName = "6"       '"ActiveGeneral" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(1).LiFields(6).FiTyp = 1          ' Typ des Feldes
        STLZK(1).LiFields(6).FiLength = 1       ' Feldlnge in Byte
        STLZK(1).LiFields(6).FiValue = ""       ' Feldwert


        STLZK(2).LiID = 2                         ' Nummer der Datensatzbeschreibung
        STLZK(2).LiName = "Location"              ' Name der Datensatzbeschreibung
        STLZK(2).LiFieldCount = 4                 ' Anzahl Felder 
        STLZK(2).LiStatus = 0                     ' 
        STLZK(2).LiType = 0
        ' Hier stellen wir den bentigten Speicher entsprechend der Feldanzahl bereit
        ReDim STLZK(2).LiFields(4)
        ' Die Datensatzlnge wird natrlich auch zur Datensatzbeschreibung gespeichert
        STLZK(2).LiLength = 20
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(2).LiFields(0).FiName = "0"       '"Id" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(2).LiFields(0).FiTyp = 1          ' Typ des Feldes
        STLZK(2).LiFields(0).FiLength = 4       ' Feldlnge in Byte
        STLZK(2).LiFields(0).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(2).LiFields(1).FiName = "1"       '"Group" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(2).LiFields(1).FiTyp = 1          ' Typ des Feldes
        STLZK(2).LiFields(1).FiLength = 4       ' Feldlnge in Byte
        STLZK(2).LiFields(1).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(2).LiFields(2).FiName = "2"       '"RefTime" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(2).LiFields(2).FiTyp = 1          ' Typ des Feldes
        STLZK(2).LiFields(2).FiLength = 4       ' Feldlnge in Byte
        STLZK(2).LiFields(2).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(2).LiFields(3).FiName = "3"       '"RefTimeNoPin" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(2).LiFields(3).FiTyp = 1          ' Typ des Feldes
        STLZK(2).LiFields(3).FiLength = 4       ' Feldlnge in Byte
        STLZK(2).LiFields(3).FiValue = ""       ' Feldwert


        STLZK(3).LiID = 3                     ' Nummer der Datensatzbeschreibung
        STLZK(3).LiName = "Time"              ' Name der Datensatzbeschreibung
        STLZK(3).LiFieldCount = 4             ' Anzahl Felder 
        STLZK(3).LiStatus = 0                 ' 
        STLZK(3).LiType = 0
        ' Hier stellen wir den bentigten Speicher entsprechend der Feldanzahl bereit
        ReDim STLZK(3).LiFields(4)
        ' Die Datensatzlnge wird natrlich auch zur Datensatzbeschreibung gespeichert
        STLZK(3).LiLength = 25
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(3).LiFields(0).FiName = "0"       '"Id" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(3).LiFields(0).FiTyp = 1          ' Typ des Feldes
        STLZK(3).LiFields(0).FiLength = 4       ' Feldlnge in Byte
        STLZK(3).LiFields(0).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(3).LiFields(1).FiName = "1"       '"Weekdays" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(3).LiFields(1).FiTyp = 1          ' Typ des Feldes
        STLZK(3).LiFields(1).FiLength = 7       ' Feldlnge in Byte
        STLZK(3).LiFields(1).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(3).LiFields(2).FiName = "2"       '"TimeStart" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(3).LiFields(2).FiTyp = 4          ' Typ des Feldes
        STLZK(3).LiFields(2).FiLength = 5       ' Feldlnge in Byte
        STLZK(3).LiFields(2).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(3).LiFields(3).FiName = "3"       '"TimeEnd" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(3).LiFields(3).FiTyp = 4          ' Typ des Feldes
        STLZK(3).LiFields(3).FiLength = 5       ' Feldlnge in Byte
        STLZK(3).LiFields(3).FiValue = ""       ' Feldwert


        STLZK(4).LiID = 4                        ' Nummer der Datensatzbeschreibung
        STLZK(4).LiName = "Holiday"              ' Name der Datensatzbeschreibung
        STLZK(4).LiFieldCount = 3                ' Anzahl Felder 
        STLZK(4).LiStatus = 0                    ' 
        STLZK(4).LiType = 0
        ' Hier stellen wir den bentigten Speicher entsprechend der Feldanzahl bereit
        ReDim STLZK(4).LiFields(3)
        ' Die Datensatzlnge wird natrlich auch zur Datensatzbeschreibung gespeichert
        STLZK(4).LiLength = 21
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(4).LiFields(0).FiName = "0"       '"Day" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(4).LiFields(0).FiTyp = 4          ' Typ des Feldes
        STLZK(4).LiFields(0).FiLength = 10      ' Feldlnge in Byte
        STLZK(4).LiFields(0).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(4).LiFields(1).FiName = "1"       '"RefGroup" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(4).LiFields(1).FiTyp = 1          ' Typ des Feldes
        STLZK(4).LiFields(1).FiLength = 4       ' Feldlnge in Byte
        STLZK(4).LiFields(1).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(4).LiFields(2).FiName = "2"       '"RefTime" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(4).LiFields(2).FiTyp = 1          ' Typ des Feldes
        STLZK(4).LiFields(2).FiLength = 4       ' Feldlnge in Byte
        STLZK(4).LiFields(2).FiValue = ""       ' Feldwert


        STLZK(5).LiID = 5                      ' Nummer der Datensatzbeschreibung
        STLZK(5).LiName = "Event"              ' Name der Datensatzbeschreibung
        STLZK(5).LiFieldCount = 4              ' Anzahl Felder 
        STLZK(5).LiStatus = 0                  ' 
        STLZK(5).LiType = 0
        ' Hier stellen wir den bentigten Speicher entsprechend der Feldanzahl bereit
        ReDim STLZK(5).LiFields(4)
        ' Die Datensatzlnge wird natrlich auch zur Datensatzbeschreibung gespeichert
        STLZK(5).LiLength = 17
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(5).LiFields(0).FiName = "0"       '"RefReader" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(5).LiFields(0).FiTyp = 1          ' Typ des Feldes
        STLZK(5).LiFields(0).FiLength = 4       ' Feldlnge in Byte
        STLZK(5).LiFields(0).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(5).LiFields(1).FiName = "1"       '"PortIn" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(5).LiFields(1).FiTyp = 1          ' Typ des Feldes
        STLZK(5).LiFields(1).FiLength = 1       ' Feldlnge in Byte
        STLZK(5).LiFields(1).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(5).LiFields(2).FiName = "2"       '"RefAction" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(5).LiFields(2).FiTyp = 1          ' Typ des Feldes
        STLZK(5).LiFields(2).FiLength = 4       ' Feldlnge in Byte
        STLZK(5).LiFields(2).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(5).LiFields(3).FiName = "3"       '"RefTime" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(5).LiFields(3).FiTyp = 1          ' Typ des Feldes
        STLZK(5).LiFields(3).FiLength = 4       ' Feldlnge in Byte
        STLZK(5).LiFields(3).FiValue = ""       ' Feldwert


        STLZK(6).LiID = 6                       ' Nummer der Datensatzbeschreibung
        STLZK(6).LiName = "Action"              ' Name der Datensatzbeschreibung
        STLZK(6).LiFieldCount = 5               ' Anzahl Felder 
        STLZK(6).LiStatus = 0                   ' 
        STLZK(6).LiType = 0
        ' Hier stellen wir den bentigten Speicher entsprechend der Feldanzahl bereit
        ReDim STLZK(6).LiFields(5)
        ' Die Datensatzlnge wird natrlich auch zur Datensatzbeschreibung gespeichert
        STLZK(6).LiLength = 21
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(6).LiFields(0).FiName = "0"       '"Id" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(6).LiFields(0).FiTyp = 1          ' Typ des Feldes
        STLZK(6).LiFields(0).FiLength = 4       ' Feldlnge in Byte
        STLZK(6).LiFields(0).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(6).LiFields(1).FiName = "1"       '"RefReader" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(6).LiFields(1).FiTyp = 1          ' Typ des Feldes
        STLZK(6).LiFields(1).FiLength = 4       ' Feldlnge in Byte
        STLZK(6).LiFields(1).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(6).LiFields(2).FiName = "2"       '"PortOut" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(6).LiFields(2).FiTyp = 1          ' Typ des Feldes
        STLZK(6).LiFields(2).FiLength = 1       ' Feldlnge in Byte
        STLZK(6).LiFields(2).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(6).LiFields(3).FiName = "3"       '"Elapse" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(6).LiFields(3).FiTyp = 1          ' Typ des Feldes
        STLZK(6).LiFields(3).FiLength = 3       ' Feldlnge in Byte
        STLZK(6).LiFields(3).FiValue = ""       ' Feldwert
        ' Jetzt den Datensatz im Detail anschauhen (jedes einzelne Feld)
        STLZK(6).LiFields(4).FiName = "4"       '"RefTime" Name des Feldes erst ab Version 04.01.04.50 mglich
        STLZK(6).LiFields(4).FiTyp = 1          ' Typ des Feldes
        STLZK(6).LiFields(4).FiLength = 4       ' Feldlnge in Byte
        STLZK(6).LiFields(4).FiValue = ""       ' Feldwert


    End Function


    ' Object for CallBack Aufrufe
    Public Function Result_From_CallBack() As Integer

        If (bCallBack = True) Then
            Return CBFunction()
        Else
            Return 0
        End If

    End Function


    Public Function CBFunction() As Integer
        If (DFComDLLSample.MainProgressBar.Value = 100) Then
            DFComDLLSample.MainProgressBar.Value = 0
        End If
        DFComDLLSample.MainProgressBar.Value += 1
        Return 1
    End Function

End Module


